[tox]
envlist =
        py36,py37,lint,code-formatter-check,bumpversion,make-docs,pypi-upload,pypi-check

[testenv:lint]
skip_install = true
deps = flake8
        pydocstyle < 4.0.0
        flake8-import-order
        flake8-blind-except
        flake8-builtins
        flake8-docstrings
        flake8-rst-docstrings
        flake8-logging-format
commands = flake8 src/

[testenv:code-formatter]
skip_install = true
deps = black
commands = black {posargs} --line-length 120 src/

[testenv:bumpversion]
skip_install = true
deps = bumpversion
commands = bumpversion --allow-dirty --verbose {posargs}

[testenv:make-docs]
skip_install = true
deps = sphinx
        sphinx-rtd-theme
        sphinxcontrib-napoleon
commands = sphinx-build -c docs/source/ -b html docs/source/ docs/build

[testenv:pypi-upload]
skip_install = true
deps = twine
setenv =
        TWINE_USERNAME={env:PYPI_PRODUCTION_USERNAME}
        TWINE_PASSWORD={env:PYPI_PRODUCTION_PASSWORD}
commands = twine upload dist/*

[testenv:pypi-check]
skip_install = true
deps = twine
commands = twine check dist/*
